wire clk;
	internal_osc_altufm_osc_518 internal_osc(clk, 1'b1);
	
	assign ledGreen = 1'b1;
	assign ledYellow = 1'b1;
	assign csRam = 1'b1;
	assign csRom = 1'b0;
	assign oeRom = 1'b0;
	assign weRom = 1'b1;
	
	//assign dataBus = !reset ? 8'b11111111 : 8'bzzzzzzzz;
	
	reg [18:0] addr;
	assign addrBus = addr;
	
	reg sckOut;
	assign sck = sckOut;
	
	`define sReadDC   4'b0000
	`define sReadByte 4'b0001
	`define sRunSPI   4'b0010
	`define sInit0    4'b0011
	`define sInit1    4'b0100
	`define sInit2    4'b0101
	`define sHalt     4'b0110
	`define sWait0		4'b0111
	`define sWait1    4'b1000
	
	reg [3:0] state;

	reg [20:0] clkdiv;
	always @(posedge clk or negedge reset) begin
		if (!reset)
			clkdiv <= 0;
		else if (state == `sInit1 || state == `sWait0)
			clkdiv <= 0;
		else
			clkdiv <= clkdiv + 1'b1;
	end
	
	reg [7:0] spiOut;
	reg [3:0] spiCount;
	reg lcdDCOut;
	assign lcdDC = lcdDCOut;
	reg lcdCSOut;
	assign lcdCS = lcdCSOut;
	reg lcdResetOut;
	assign lcdReset = lcdResetOut;
	assign mosi = spiOut[7];
	
	always @(posedge clk or negedge reset) begin
		if (!reset) begin
			sckOut <= 0;
			lcdCSOut <= 1'b1;
			lcdResetOut <= 1'b0;
		end
		else if (state == `sInit0)  begin
			lcdResetOut <= 1'b0;
			lcdCSOut <= 1'b0;
		end	
		else if (state == `sInit1)
			lcdResetOut <= 1'b1;
		else if (state == `sInit2)
			lcdResetOut <= 1'b1;
		else if (state == `sReadDC) begin
			lcdDCOut <= dataBus[0];
			lcdCSOut <= 1'b1;
		end
		else if (state == `sReadByte) begin
			spiOut <= dataBus;
			sckOut <= 0;
			spiCount <= 0;
			lcdCSOut <= 0;
		end 
		else if (state == `sRunSPI) begin
			if (spiCount[0]) begin
				spiOut <= { spiOut[6:0], 1'b0 }; // left shift
				sckOut <= 1'b0;
			end else begin
				sckOut <= 1'b1;
			end
			
			if (spiCount != 4'b1111)
				spiCount <= spiCount + 1'b1;
			else
				lcdCSOut <= 1'b1; // done
		end
	end
	
	always @(posedge clk or negedge reset) begin
		if (!reset) begin
			state <= `sInit0;
			addr <= 0;	
		end
		else if (state == `sInit0 && clkdiv == 21'b111111111111111111111)
			state <= `sInit1;
		else if (state == `sInit1)
			state <= `sInit2;
		else if (state == `sInit2 && clkdiv == 21'b111111111111111111111)
			state <= `sReadDC;
		else if (state == `sReadDC) begin
			addr <= addr + 1'b1;
			if (dataBus == 8'b11111111)
				state <= `sHalt;
			else if (dataBus == 8'b11111110)
				state <= `sWait0;
			else
				state <= `sReadByte;
		end
		else if (state == `sReadByte) begin
			addr <= addr + 1'b1;
			state <= `sRunSPI;
		end
		else if (state == `sRunSPI) begin
			if (spiCount != 4'b1111)
				state <= `sRunSPI;
			else
				state <= `sReadDC;
		end
		else if (state == `sHalt) begin
			state <= `sHalt;
		end
		else if (state == `sWait0) begin
			state <= `sWait1;
		end
		else if (state == `sWait1 && clkdiv == 21'b111111111111111111111) begin
			state <= `sReadDC;
		end		
	end
	
	initial begin
		state <= `sInit0;
		addr <= 0;
		sckOut <= 0;
		lcdCSOut <= 1'b1;
		lcdResetOut <= 1'b0;
		clkdiv <= 0;
	end